import logging as log

from siphon.catalog import Dataset, TDSCatalog

from .config import DotDict


def get_datasets(cfg: DotDict) -> list[Dataset]:
    log.debug("begin query THREDDS...")
    catalog = TDSCatalog(cfg.THREDDS_URL)
    flights = (
        list(range(cfg.FLIGHTNO_MIN, cfg.FLIGHTNO_MAX + 1))
        if cfg.FLIGHTNO_MIN != -1 and cfg.FLIGHTNO_MAX != -1
        else cfg.FLIGHTS
    )
    datasets = []

    for i, ds in enumerate(catalog.datasets):
        if not (ds.startswith(cfg.FNAME_PREFIX) and ds.endswith(cfg.FNAME_SUFFIX)):
            continue
        if int(ds.split("_")[2]) not in flights:
            continue

        datasets.append(catalog.datasets[i])
    log.debug("THREDDS query completed")
    return datasets
